diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/he-ru.h ns-3.44/src/wifi/model/he/he-ru.h
--- ns-3.43/src/wifi/model/he/he-ru.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/he-ru.h	2025-03-09 16:55:49.791372500 -0700
@@ -63,58 +63,58 @@
         /**
          * Constructor
          *
-         * \param ruType the RU type
-         * \param index the RU index (starting at 1)
-         * \param primary80MHz whether the RU is allocated in the primary 80MHz channel
+         * @param ruType the RU type
+         * @param index the RU index (starting at 1)
+         * @param primary80MHz whether the RU is allocated in the primary 80MHz channel
          */
         RuSpec(RuType ruType, std::size_t index, bool primary80MHz);
 
         /**
          * Get the RU type
          *
-         * \return the RU type
+         * @return the RU type
          */
         RuType GetRuType() const;
         /**
          * Get the RU index
          *
-         * \return the RU index
+         * @return the RU index
          */
         std::size_t GetIndex() const;
         /**
          * Get the primary 80 MHz flag
          *
-         * \return true if the RU is in the primary 80 MHz channel and false otherwise
+         * @return true if the RU is in the primary 80 MHz channel and false otherwise
          */
         bool GetPrimary80MHz() const;
         /**
          * Get the RU PHY index
          *
-         * \param bw the width of the channel of which the RU is part
-         * \param p20Index the index of the primary20 channel
-         * \return the RU PHY index
+         * @param bw the width of the channel of which the RU is part
+         * @param p20Index the index of the primary20 channel
+         * @return the RU PHY index
          */
         std::size_t GetPhyIndex(MHz_u bw, uint8_t p20Index) const;
 
         /**
          * Compare this RU to the given RU.
          *
-         * \param other the given RU
-         * \return true if this RU compares equal to the given RU, false otherwise
+         * @param other the given RU
+         * @return true if this RU compares equal to the given RU, false otherwise
          */
         bool operator==(const RuSpec& other) const;
         /**
          * Compare this RU to the given RU.
          *
-         * \param other the given RU
-         * \return true if this RU differs from the given RU, false otherwise
+         * @param other the given RU
+         * @return true if this RU differs from the given RU, false otherwise
          */
         bool operator!=(const RuSpec& other) const;
         /**
          * Compare this RU to the given RU.
          *
-         * \param other the given RU
-         * \return true if this RU is smaller than the given RU, false otherwise
+         * @param other the given RU
+         * @return true if this RU is smaller than the given RU, false otherwise
          */
         bool operator<(const RuSpec& other) const;
 
@@ -133,16 +133,16 @@
         /**
          * Constructor.
          *
-         * \param channelWidth the channel width
-         * \param p20Index the index of the primary20 channel
+         * @param channelWidth the channel width
+         * @param p20Index the index of the primary20 channel
          */
         RuSpecCompare(MHz_u channelWidth, uint8_t p20Index);
         /**
          * Function call operator.
          *
-         * \param lhs left hand side RU
-         * \param rhs right hand side RU
-         * \return true if the left hand side RU has its leftmost tone at a lower
+         * @param lhs left hand side RU
+         * @param rhs right hand side RU
+         * @return true if the left hand side RU has its leftmost tone at a lower
          *         frequency than the leftmost tone of the right hand side RU,
          *         false otherwise
          */
@@ -157,9 +157,9 @@
      * Get the number of distinct RUs of the given type (number of tones)
      * available in a HE PPDU of the given bandwidth.
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ruType the RU type (number of tones)
-     * \return the number of distinct RUs available
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @return the number of distinct RUs available
      */
     static std::size_t GetNRus(MHz_u bw, RuType ruType);
 
@@ -167,9 +167,9 @@
      * Get the set of distinct RUs of the given type (number of tones)
      * available in a HE PPDU of the given bandwidth.
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ruType the RU type (number of tones)
-     * \return the set of distinct RUs available
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @return the set of distinct RUs available
      */
     static std::vector<HeRu::RuSpec> GetRusOfType(MHz_u bw, HeRu::RuType ruType);
 
@@ -177,9 +177,9 @@
      * Get the set of 26-tone RUs that can be additionally allocated if the given
      * bandwidth is split in RUs of the given type.
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ruType the RU type (number of tones)
-     * \return the set of 26-tone RUs that can be additionally allocated
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @return the set of 26-tone RUs that can be additionally allocated
      */
     static std::vector<HeRu::RuSpec> GetCentral26TonesRus(MHz_u bw, HeRu::RuType ruType);
 
@@ -192,10 +192,10 @@
      * the 160 MHz channel (i.e. -1012 to 1012). The PHY index parameter is used to
      * distinguish between lower and higher 80 MHz subchannels.
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ruType the RU type (number of tones)
-     * \param phyIndex the PHY index (starting at 1) of the RU
-     * \return the subcarrier range of the specified RU
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @param phyIndex the PHY index (starting at 1) of the RU
+     * @return the subcarrier range of the specified RU
      */
     static SubcarrierGroup GetSubcarrierGroup(MHz_u bw, RuType ruType, std::size_t phyIndex);
 
@@ -204,10 +204,10 @@
      * Note that for channel width of 160 MHz the returned range is relative to
      * the 160 MHz channel (i.e. -1012 to 1012).
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ru the given RU allocation
-     * \param v the given set of RUs
-     * \return true if the given RU overlaps with the given set of RUs.
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ru the given RU allocation
+     * @param v the given set of RUs
+     * @return true if the given RU overlaps with the given set of RUs.
      */
     static bool DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v);
 
@@ -216,11 +216,11 @@
      * Note that for channel width of 160 MHz the returned range is relative to
      * the 160 MHz channel (i.e. -1012 to 1012).
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param ru the given RU allocation
-     * \param toneRanges the given set of tone ranges
-     * \param p20Index the index of the primary20 channel
-     * \return true if the given RU overlaps with the given set of tone ranges.
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param ru the given RU allocation
+     * @param toneRanges the given set of tone ranges
+     * @param p20Index the index of the primary20 channel
+     * @return true if the given RU overlaps with the given set of tone ranges.
      */
     static bool DoesOverlap(MHz_u bw,
                             RuSpec ru,
@@ -232,26 +232,26 @@
      * reference RU allocation.
      * Note that an assert is generated if the RU allocation is not found.
      *
-     * \param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * \param referenceRu the reference RU allocation
-     * \param searchedRuType the searched RU type
-     * \return the searched RU allocation.
+     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
+     * @param referenceRu the reference RU allocation
+     * @param searchedRuType the searched RU type
+     * @return the searched RU allocation.
      */
     static RuSpec FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType);
 
     /**
      * Get the approximate bandwidth occupied by a RU.
      *
-     * \param ruType the RU type
-     * \return the approximate bandwidth occupied by the RU
+     * @param ruType the RU type
+     * @return the approximate bandwidth occupied by the RU
      */
     static MHz_u GetBandwidth(RuType ruType);
 
     /**
      * Get the RU corresponding to the approximate bandwidth.
      *
-     * \param bandwidth the approximate bandwidth occupied by the RU
-     * \return the RU type
+     * @param bandwidth the approximate bandwidth occupied by the RU
+     * @return the RU type
      */
     static RuType GetRuType(MHz_u bandwidth);
 
@@ -261,12 +261,12 @@
      * an RU subject to the constraint that all the stations must be assigned an RU
      * of the same size (in terms of number of tones).
      *
-     * \param bandwidth the channel bandwidth
-     * \param nStations the number of candidate stations. On return, it is set to
+     * @param bandwidth the channel bandwidth
+     * @param nStations the number of candidate stations. On return, it is set to
      *                  the number of stations that are assigned an RU
      * \param[out] nCentral26TonesRus the number of additional 26-tone RUs that can be
      *                                allocated if the returned RU size is greater than 26 tones
-     * \return the RU type
+     * @return the RU type
      */
     static RuType GetEqualSizedRusForStations(MHz_u bandwidth,
                                               std::size_t& nStations,
@@ -288,14 +288,14 @@
     static const RuAllocationMap m_heRuAllocations;
 
     /// Get the RU specs based on RU_ALLOCATION
-    /// \param ruAllocation 8 bit RU_ALLOCATION value
-    /// \return RU spec associated with the RU_ALLOCATION
+    /// @param ruAllocation 8 bit RU_ALLOCATION value
+    /// @return RU spec associated with the RU_ALLOCATION
     static std::vector<RuSpec> GetRuSpecs(uint8_t ruAllocation);
 
     /// Get the RU_ALLOCATION value for equal size RUs
-    /// \param ruType equal size RU type (generated by GetEqualSizedRusForStations)
-    /// \param isOdd if number of stations is an odd number
-    /// \return RU_ALLOCATION value
+    /// @param ruType equal size RU type (generated by GetEqualSizedRusForStations)
+    /// @param isOdd if number of stations is an odd number
+    /// @return RU_ALLOCATION value
     static uint8_t GetEqualizedRuAllocation(RuType ruType, bool isOdd);
 
     /// Empty 242-tone RU identifier
@@ -303,20 +303,20 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param ruType the RU type
- * \returns a reference to the stream
+ * @param os the stream
+ * @param ruType the RU type
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const HeRu::RuType& ruType);
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param ru the RU
- * \returns a reference to the stream
+ * @param os the stream
+ * @param ru the RU
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const HeRu::RuSpec& ru);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/mu-edca-parameter-set.h ns-3.44/src/wifi/model/he/mu-edca-parameter-set.h
--- ns-3.43/src/wifi/model/he/mu-edca-parameter-set.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/mu-edca-parameter-set.h	2025-03-09 16:55:49.791372500 -0700
@@ -18,8 +18,8 @@
 {
 
 /**
- * \brief The MU EDCA Parameter Set
- * \ingroup wifi
+ * @brief The MU EDCA Parameter Set
+ * @ingroup wifi
  *
  * The 802.11ax MU EDCA Parameter Set.
  */
@@ -34,7 +34,7 @@
     /**
      * Set the QoS Info field in the MuEdcaParameterSet information element.
      *
-     * \param qosInfo the QoS Info field in the MuEdcaParameterSet information element
+     * @param qosInfo the QoS Info field in the MuEdcaParameterSet information element
      */
     void SetQosInfo(uint8_t qosInfo);
     /**
@@ -42,8 +42,8 @@
      * field corresponding to the given AC Index (<i>aci</i>). Note that <i>aifsn</i>
      * can either be zero (EDCA disabled) or in the range from 2 to 15.
      *
-     * \param aci the AC Index
-     * \param aifsn the value for the AIFSN subfield
+     * @param aci the AC Index
+     * @param aifsn the value for the AIFSN subfield
      */
     void SetMuAifsn(uint8_t aci, uint8_t aifsn);
     /**
@@ -51,8 +51,8 @@
      * field corresponding to the given AC Index (<i>aci</i>). Note that <i>cwMin</i>
      * must be a power of 2 minus 1 in the range from 0 to 32767.
      *
-     * \param aci the AC Index
-     * \param cwMin the CWmin value encoded by the ECWmin field
+     * @param aci the AC Index
+     * @param cwMin the CWmin value encoded by the ECWmin field
      */
     void SetMuCwMin(uint8_t aci, uint16_t cwMin);
     /**
@@ -60,8 +60,8 @@
      * field corresponding to the given AC Index (<i>aci</i>). Note that <i>cwMax</i>
      * must be a power of 2 minus 1 in the range from 0 to 32767.
      *
-     * \param aci the AC Index
-     * \param cwMax the CWmax value encoded by the ECWmax field
+     * @param aci the AC Index
+     * @param cwMax the CWmax value encoded by the ECWmax field
      */
     void SetMuCwMax(uint8_t aci, uint16_t cwMax);
     /**
@@ -72,47 +72,47 @@
      * that the MU EDCA Parameter Set element must not be sent and therefore it is
      * only allowed if the MU EDCA Timer is set to 0 for all ACs.
      *
-     * \param aci the AC Index
-     * \param timer the value for the timer encoded by the MU EDCA Timer field
+     * @param aci the AC Index
+     * @param timer the value for the timer encoded by the MU EDCA Timer field
      */
     void SetMuEdcaTimer(uint8_t aci, Time timer);
 
     /**
      * Return the QoS Info field in the MuEdcaParameterSet information element.
      *
-     * \return the QoS Info field in the MuEdcaParameterSet information element
+     * @return the QoS Info field in the MuEdcaParameterSet information element
      */
     uint8_t GetQosInfo() const;
     /**
      * Get the AIFSN subfield of the ACI/AIFSN field in the MU AC Parameter Record
      * field corresponding to the given AC Index (<i>aci</i>).
      *
-     * \param aci the AC Index
-     * \return the value of the AIFSN subfield
+     * @param aci the AC Index
+     * @return the value of the AIFSN subfield
      */
     uint8_t GetMuAifsn(uint8_t aci) const;
     /**
      * Get the CWmin value encoded by the ECWmin subfield of the ECWmin/ECWmax field
      * in the MU AC Parameter Record field corresponding to the given AC Index (<i>aci</i>).
      *
-     * \param aci the AC Index
-     * \return the CWmin value
+     * @param aci the AC Index
+     * @return the CWmin value
      */
     uint16_t GetMuCwMin(uint8_t aci) const;
     /**
      * Get the CWmax value encoded by the ECWmax subfield of the ECWmin/ECWmax field
      * in the MU AC Parameter Record field corresponding to the given AC Index (<i>aci</i>).
      *
-     * \param aci the AC Index
-     * \return the CWmax value
+     * @param aci the AC Index
+     * @return the CWmax value
      */
     uint16_t GetMuCwMax(uint8_t aci) const;
     /**
      * Get the MU EDCA Timer value encoded in the MU AC Parameter Record field corresponding
      * to the given AC Index (<i>aci</i>).
      *
-     * \param aci the AC Index
-     * \return the MU EDCA Timer value
+     * @param aci the AC Index
+     * @return the MU EDCA Timer value
      */
     Time GetMuEdcaTimer(uint8_t aci) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/multi-user-scheduler.cc ns-3.44/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.43/src/wifi/model/he/multi-user-scheduler.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/multi-user-scheduler.cc	2025-03-09 16:55:49.791372500 -0700
@@ -64,11 +64,27 @@
                           "channel access.",
                           BooleanValue(true),
                           MakeBooleanAccessor(&MultiUserScheduler::m_restartTimerUponAccess),
-                          MakeBooleanChecker());
+                          MakeBooleanChecker())
+            .AddAttribute("DefaultTbPpduDuration",
+                          "Default duration of TB PPDUs solicited via a Basic Trigger Frame. "
+                          "This value is used to compute the Duration/ID field of BSRP Trigger "
+                          "Frames sent when the TXOP Limit is zero and the FrameExchangeManager "
+                          "continues the TXOP a SIFS after receiving response to the BSRP TF. "
+                          "This value shall also be used by subclasses when they have no other "
+                          "information available to determine the TX duration of solicited PPDUs. "
+                          "The default value roughly corresponds to half the maximum PPDU TX "
+                          "duration.",
+                          TimeValue(MilliSeconds(2)),
+                          MakeTimeAccessor(&MultiUserScheduler::m_defaultTbPpduDuration),
+                          MakeTimeChecker());
     return tid;
 }
 
 MultiUserScheduler::MultiUserScheduler()
+    : m_isUnprotectedEmlsrClient([this](uint8_t linkId, Mac48Address address) {
+          return m_apMac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(address) &&
+                 !m_apMac->GetFrameExchangeManager(linkId)->GetProtectedStas().contains(address);
+      })
 {
 }
 
@@ -186,6 +202,12 @@
     return StaticCast<HeFrameExchangeManager>(m_apMac->GetFrameExchangeManager(linkId));
 }
 
+Time
+MultiUserScheduler::GetExtraTimeForBsrpTfDurationId(uint8_t linkId) const
+{
+    return m_defaultTbPpduDuration;
+}
+
 void
 MultiUserScheduler::AccessReqTimeout(uint8_t linkId)
 {
@@ -259,9 +281,10 @@
 }
 
 MultiUserScheduler::TxFormat
-MultiUserScheduler::GetLastTxFormat(uint8_t linkId)
+MultiUserScheduler::GetLastTxFormat(uint8_t linkId) const
 {
-    return m_lastTxInfo[linkId].lastTxFormat;
+    const auto it = m_lastTxInfo.find(linkId);
+    return it != m_lastTxInfo.cend() ? it->second.lastTxFormat : NO_TX;
 }
 
 MultiUserScheduler::DlMuInfo&
@@ -333,6 +356,141 @@
     GetHeFem(m_linkId)->SetTargetRssi(m_lastTxInfo[m_linkId].ulInfo.trigger);
 }
 
+void
+MultiUserScheduler::RemoveRecipientsFromTf(
+    uint8_t linkId,
+    CtrlTriggerHeader& trigger,
+    WifiTxParameters& txParams,
+    std::function<bool(uint8_t, Mac48Address)> predicate) const
+{
+    NS_LOG_FUNCTION(this << linkId << &txParams);
+
+    const auto& aidAddrMap = m_apMac->GetStaList(linkId);
+
+    for (auto userInfoIt = trigger.begin(); userInfoIt != trigger.end();)
+    {
+        const auto addressIt = aidAddrMap.find(userInfoIt->GetAid12());
+        NS_ASSERT_MSG(addressIt != aidAddrMap.cend(),
+                      "AID " << userInfoIt->GetAid12() << " not found");
+        const auto address = addressIt->second;
+
+        if (predicate(linkId, address))
+        {
+            NS_LOG_INFO("Removing User Info field addressed to " << address);
+
+            userInfoIt = trigger.RemoveUserInfoField(userInfoIt);
+
+            if (txParams.m_acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA)
+            {
+                auto acknowledgment =
+                    static_cast<WifiUlMuMultiStaBa*>(txParams.m_acknowledgment.get());
+                for (auto it = acknowledgment->stationsReceivingMultiStaBa.begin();
+                     it != acknowledgment->stationsReceivingMultiStaBa.end();)
+                {
+                    if (it->first.first == address)
+                    {
+                        it = acknowledgment->stationsReceivingMultiStaBa.erase(it);
+                    }
+                    else
+                    {
+                        ++it;
+                    }
+                }
+            }
+        }
+        else
+        {
+            ++userInfoIt;
+        }
+    }
+}
+
+void
+MultiUserScheduler::RemoveRecipientsFromDlMu(
+    uint8_t linkId,
+    WifiPsduMap& psduMap,
+    WifiTxParameters& txParams,
+    std::function<bool(uint8_t, Mac48Address)> predicate) const
+{
+    NS_LOG_FUNCTION(this << linkId << &txParams);
+
+    const auto& aidAddrMap = m_apMac->GetStaList(linkId);
+
+    for (auto psduMapIt = psduMap.begin(); psduMapIt != psduMap.end();)
+    {
+        const auto addressIt = aidAddrMap.find(psduMapIt->first);
+        NS_ASSERT_MSG(addressIt != aidAddrMap.cend(), "AID " << psduMapIt->first << " not found");
+        const auto address = addressIt->second;
+
+        if (predicate(linkId, address))
+        {
+            NS_LOG_INFO("Removing PSDU addressed to " << address);
+
+            txParams.m_txVector.GetHeMuUserInfoMap().erase(psduMapIt->first);
+            psduMapIt = psduMap.erase(psduMapIt);
+
+            if (txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE)
+            {
+                auto acknowledgment =
+                    static_cast<WifiDlMuBarBaSequence*>(txParams.m_acknowledgment.get());
+                acknowledgment->stationsReplyingWithNormalAck.erase(address);
+                acknowledgment->stationsReplyingWithBlockAck.erase(address);
+                acknowledgment->stationsSendBlockAckReqTo.erase(address);
+            }
+            else if (txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_TF_MU_BAR)
+            {
+                auto acknowledgment =
+                    static_cast<WifiDlMuTfMuBar*>(txParams.m_acknowledgment.get());
+                acknowledgment->stationsReplyingWithBlockAck.erase(address);
+            }
+            else if (txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
+            {
+                auto acknowledgment =
+                    static_cast<WifiDlMuAggregateTf*>(txParams.m_acknowledgment.get());
+                acknowledgment->stationsReplyingWithBlockAck.erase(address);
+            }
+        }
+        else
+        {
+            ++psduMapIt;
+        }
+    }
+}
+
+void
+MultiUserScheduler::NotifyProtectionCompleted(uint8_t linkId,
+                                              WifiPsduMap& psduMap,
+                                              WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << linkId << &txParams);
+
+    if (txParams.m_txVector.IsDlMu())
+    {
+        NS_ASSERT(GetLastTxFormat(linkId) == DL_MU_TX);
+
+        UpdateDlMuAfterProtection(linkId, psduMap, txParams);
+    }
+    else if (IsTrigger(psduMap))
+    {
+        NS_ASSERT(GetLastTxFormat(linkId) == UL_MU_TX);
+
+        UpdateTriggerFrameAfterProtection(linkId, GetUlMuInfo(linkId).trigger, txParams);
+
+        if (GetUlMuInfo(linkId).trigger.GetNUserInfoFields() == 0)
+        {
+            NS_LOG_INFO("No User Info field left");
+            psduMap.clear();
+        }
+        else
+        {
+            auto mpdu = GetTriggerFrame(GetUlMuInfo(linkId).trigger, linkId);
+            GetUlMuInfo(linkId).macHdr = mpdu->GetHeader();
+            psduMap =
+                WifiPsduMap{{SU_STA_ID, GetHeFem(linkId)->GetWifiPsdu(mpdu, txParams.m_txVector)}};
+        }
+    }
+}
+
 uint32_t
 MultiUserScheduler::GetMaxSizeOfQosNullAmpdu(const CtrlTriggerHeader& trigger) const
 {
